Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.ws.rs.ext
Interface MessageBodyWriter<T>

    public interface MessageBodyWriter<T>

Contract for a provider that supports the conversion of a Java type to a stream. To add a `MessageBodyWriter` implementation, annotate the implementation class with `@Provider`. A `MessageBodyWriter` implementation may be annotated with `Produces` to restrict the media types for which it will be considered suitable.

See Also:
  `Provider`, `Produces`

Method Summary
`long` | `getSize(T t, java.lang.Class<?> type, java.lang.reflect.Type genericType, java.lang.annotation.Annotation[] annotations, MediaType mediaType)` Called before `writeTo` to ascertain the length in bytes of the serialized form of `t`.
`boolean` | `isWriteable(java.lang.Class<?> type, java.lang.reflect.Type genericType, java.lang.annotation.Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyWriter supports a particular type.
`void` | `writeTo(T t, java.lang.Class<?> type, java.lang.reflect.Type genericType, java.lang.annotation.Annotation[] annotations, MediaType mediaType, MultivaluedMap<java.lang.String,java.lang.Object> httpHeaders, java.io.OutputStream entityStream)` Write a type to an HTTP response.

Method Detail

### isWriteable

    boolean isWriteable(java.lang.Class<?> type,
                        java.lang.reflect.Type genericType,
                        java.lang.annotation.Annotation[] annotations,
                        MediaType mediaType)

  Ascertain if the MessageBodyWriter supports a particular type.

  Parameters:
    `type` - the class of object that is to be written.
    `genericType` - the type of object to be written, obtained either by reflection of a resource method return type or via inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
    `annotations` - an array of the annotations on the resource method that returns the object.
    `mediaType` - the media type of the HTTP entity.
  Returns:
    true if the type is supported, otherwise false.

### getSize

    long getSize(T t,
                 java.lang.Class<?> type,
                 java.lang.reflect.Type genericType,
                 java.lang.annotation.Annotation[] annotations,
                 MediaType mediaType)

  Called before `writeTo` to ascertain the length in bytes of the serialized form of `t`. A non-negative return value is used in a HTTP `Content-Length` header.

  Parameters:
    `t` - the instance to write
    `type` - the class of object that is to be written.
    `genericType` - the type of object to be written, obtained either by reflection of a resource method return type or by inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
    `annotations` - an array of the annotations on the resource method that returns the object.
    `mediaType` - the media type of the HTTP entity.
  Returns:
    length in bytes or -1 if the length cannot be determined in advance

### writeTo

    void writeTo(T t,
                 java.lang.Class<?> type,
                 java.lang.reflect.Type genericType,
                 java.lang.annotation.Annotation[] annotations,
                 MediaType mediaType,
                 MultivaluedMap<java.lang.String,java.lang.Object> httpHeaders,
                 java.io.OutputStream entityStream)
                 throws java.io.IOException,
                        WebApplicationException

  Write a type to an HTTP response. The response header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the response body.

  Parameters:
    `t` - the instance to write.
    `type` - the class of object that is to be written.
    `genericType` - the type of object to be written, obtained either by reflection of a resource method return type or by inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
    `annotations` - an array of the annotations on the resource method that returns the object.
    `mediaType` - the media type of the HTTP entity.
    `httpHeaders` - a mutable map of the HTTP response headers.
    `entityStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
  Throws:
    `java.io.IOException` - if an IO error arises
    `WebApplicationException` - if a specific HTTP error response needs to be produced. Only effective if thrown prior to the response being committed.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008 Sun Microsystems, Inc. All Rights Reserved.